Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/setspv.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/setspv.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/setspv.F90	(revision 227)
@@ -69,5 +69,6 @@
          call abort
       endif
-    
+	
+!$OMP MASTER        
       nb=0
       ierr=0
@@ -98,5 +99,6 @@
       BWNV(L_NSPECTV)  =lastband(1)
       BWNV(L_NSPECTV+1)=lastband(2)
-
+!$OMP END MASTER
+!$OMP BARRIER
 
       print*,'setspv: VI band limits:'
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/soil.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/soil.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/soil.F	(revision 227)
@@ -17,6 +17,6 @@
 !-----------------------------------------------------------------------
 
-      include "dimensions.h"
-      include "dimphys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
 
 
@@ -45,4 +45,5 @@
       real,dimension(:,:),save,allocatable :: beta ! beta_k coefficients
       real,save :: mu
+!$OMP THREADPRIVATE(mthermdiff,thermdiff,coefq,coefd,alph,beta,mu)
             
 ! local variables:
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/start2archive.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/start2archive.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/start2archive.F	(revision 227)
@@ -27,8 +27,10 @@
 ! to use  'getin'
       USE ioipsl_getincom
+      USE planete_mod
 
       implicit none
 
 #include "dimensions.h"
+      integer, parameter :: ngridmx = (2+(jjm-1)*iim - 1/jjm) 
 #include "paramet.h"
 #include "comconst.h"
@@ -41,6 +43,6 @@
 #include "ener.h"
 
-#include "dimphys.h"
-#include "planete.h"
+!#include "dimphys.h"
+!#include "planete.h"
 !#include"advtrac.h"
 #include "netcdf.inc"
@@ -69,5 +71,5 @@
       REAL tsoil(ngridmx,nsoilmx) ! Soil temperature
       REAL co2ice(ngridmx)	! CO2 ice layer
-      REAL q2(ngridmx,nlayermx+1)
+      REAL q2(ngridmx,llm+1)
       REAL,ALLOCATABLE :: qsurf(:,:)
       REAL emis(ngridmx)
@@ -80,5 +82,5 @@
 !     added by FF for cloud fraction setup
       REAL hice(ngridmx)
-      REAL cloudfrac(ngridmx,nlayermx),totalcloudfrac(ngridmx)
+      REAL cloudfrac(ngridmx,llm),totalcloudfrac(ngridmx)
 
 !     added by BC for slab ocean
@@ -199,6 +201,6 @@
 
 
-      CALL phyetat0 (ngridmx,fichnom,0,Lmodif,nsoilmx,nqtot,day_ini_fi,
-     .      timefi,
+      CALL phyetat0 (ngridmx,llm,fichnom,0,Lmodif,nsoilmx,nqtot,
+     .      day_ini_fi,timefi,
      .      tsurf,tsoil,emis,q2,qsurf,
 !       change FF 05/2011
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/stellarlong.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/stellarlong.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/stellarlong.F	(revision 227)
@@ -1,3 +1,5 @@
       SUBROUTINE stellarlong(pday,pstellong)
+      
+      USE planete_mod, ONLY: year_day, peri_day, e_elips, timeperi
       IMPLICIT NONE
 
@@ -40,5 +42,5 @@
 c   -------------
 
-#include "planete.h"
+!#include "planete.h"
 #include "comcstfi.h"
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/stokes.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/stokes.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/stokes.F90	(revision 227)
@@ -33,8 +33,10 @@
       real a,b,molrad,visc
       save a,b
+!$OMP THREADPRIVATE(a,b)
   
       LOGICAL firstcall
       SAVE firstcall
       DATA firstcall/.true./
+!$OMP THREADPRIVATE(firstcall)
 
       if (firstcall) then
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/su_gases.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/su_gases.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/su_gases.F90	(revision 227)
@@ -20,4 +20,5 @@
   !==================================================================
 
+!$OMP MASTER
   ! load gas names from file 'gases.def'
   open(90,file='gases.def',status='old',form='formatted',iostat=ierr)
@@ -122,4 +123,6 @@
   endif
   close(90)
+!$OMP END MASTER
+!$OMP BARRIER
 
 end subroutine su_gases
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/suaer_corrk.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/suaer_corrk.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/suaer_corrk.F90	(revision 227)
@@ -46,6 +46,6 @@
 #include "callkeys.h"
 !     Optical properties (read in external ASCII files)
-      INTEGER          :: nwvl  ! Number of wavelengths in
-                                ! the domain (VIS or IR)
+      INTEGER,SAVE      :: nwvl  ! Number of wavelengths in
+                                ! the domain (VIS or IR), read by master
 
 !      REAL             :: solsir ! visible to infrared ratio
@@ -53,12 +53,12 @@
 
       REAL, DIMENSION(:),&
-      ALLOCATABLE, SAVE :: wvl  ! Wavelength axis
+      ALLOCATABLE, SAVE :: wvl  ! Wavelength axis, read by master
       REAL, DIMENSION(:),&
-      ALLOCATABLE, SAVE :: radiusdyn ! Particle size axis
+      ALLOCATABLE, SAVE :: radiusdyn ! Particle size axis, read by master
 
       REAL, DIMENSION(:,:),&
-      ALLOCATABLE, SAVE :: ep,& ! Extinction coefficient Qext
-      omeg,&                    ! Single Scattering Albedo
-      gfactor                   ! Assymetry Factor
+      ALLOCATABLE, SAVE :: ep,& ! Extinction coefficient Qext, read by master
+      omeg,&                    ! Single Scattering Albedo, read by master
+      gfactor                   ! Assymetry Factor, read by master
 
 !     Local variables:
@@ -98,4 +98,5 @@
 
       CHARACTER(LEN=30), DIMENSION(naerkind,2), SAVE :: file_id
+!$OMP THREADPRIVATE(file_id)
 !---- Please indicate the names of the optical property files below
 !     Please also choose the reference wavelengths of each aerosol
@@ -203,4 +204,5 @@
 !     1.1 Open the ASCII file
 
+!$OMP MASTER
             INQUIRE(FILE=TRIM(datadir)//&
          '/'//TRIM(file_id(iaer,idomain)),&
@@ -339,4 +341,6 @@
       endif
 
+!$OMP END MASTER
+!$OMP BARRIER
 
 
@@ -432,9 +436,13 @@
 !========================================================================
 
-      DEALLOCATE(wvl)           ! wvl
-      DEALLOCATE(radiusdyn)     ! radiusdyn
-      DEALLOCATE(ep)            ! ep 
-      DEALLOCATE(omeg)          ! omeg 
-      DEALLOCATE(gfactor)       ! g
+!$OMP BARRIER
+!$OMP MASTER
+      IF (ALLOCATED(wvl)) DEALLOCATE(wvl)                 ! wvl
+      IF (ALLOCATED(radiusdyn)) DEALLOCATE(radiusdyn)     ! radiusdyn
+      IF (ALLOCATED(ep)) DEALLOCATE(ep)                   ! ep 
+      IF (ALLOCATED(omeg)) DEALLOCATE(omeg)          	  ! omeg 
+      IF (ALLOCATED(gfactor)) DEALLOCATE(gfactor)         ! g
+!$OMP END MASTER
+!$OMP BARRIER
 
       END DO                    ! Loop on iaer
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/sugas_corrk.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/sugas_corrk.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/sugas_corrk.F90	(revision 227)
@@ -28,5 +28,6 @@
 
       use gases_h
-      use ioipsl_getincom 
+!      use ioipsl_getincom
+      use ioipsl_getincom_p 
       implicit none
 
@@ -45,6 +46,6 @@
 
       ! ALLOCATABLE ARRAYS -- AS 12/2011
-      REAL*8, DIMENSION(:,:,:,:,:), ALLOCATABLE :: gasi8, gasv8
-      character*20,allocatable,DIMENSION(:) :: gastype ! for check with gnom
+      REAL*8, DIMENSION(:,:,:,:,:), ALLOCATABLE,SAVE :: gasi8, gasv8 	!read by master
+      character*20,allocatable,DIMENSION(:),SAVE :: gastype ! for check with gnom, read by master
 
       real*8 x, xi(4), yi(4), ans, p
@@ -76,4 +77,5 @@
       endif
 
+!$OMP MASTER
       ! check that database matches varactive toggle
       open(111,file=TRIM(file_path),form='formatted')
@@ -261,4 +263,6 @@
       tgasmin = tgasref(1)
       tgasmax = tgasref(L_NTREF)
+!$OMP END MASTER
+!$OMP BARRIER
 
 !-----------------------------------------------------------------------
@@ -302,5 +306,5 @@
          write(*,*)"graybody: constant absorption coefficient in visible:"
          kappa_VI=-100000.
-         call getin("kappa_VI",kappa_VI)
+         call getin_p("kappa_VI",kappa_VI)
          write(*,*)" kappa_VI = ",kappa_VI
 	 kappa_VI=kappa_VI*1.e4* mugaz * 1.672621e-27	 ! conversion from m^2/kg to cm^2/molecule         
@@ -309,5 +313,5 @@
          write(*,*)"graybody: constant absorption coefficient in InfraRed:"
          kappa_IR=-100000.
-         call getin("kappa_IR",kappa_IR)
+         call getin_p("kappa_IR",kappa_IR)
          write(*,*)" kappa_IR = ",kappa_IR	 
          kappa_IR=kappa_IR*1.e4* mugaz * 1.672621e-27	 ! conversion from m^2/kg to cm^2/molecule 
@@ -320,4 +324,5 @@
       End if
 
+!$OMP MASTER         
 !      print*,corrkdir(1:4)
       ! VISIBLE
@@ -361,10 +366,15 @@
          gasv8(1:L_NTREF,1:L_NPREF,1:L_REFVAR,1:L_NSPECTV,1:L_NGAUSS)=0.0
       endif
+!$OMP END MASTER
+!$OMP BARRIER
 
       ! INFRA-RED
       if ((corrkdir(1:4).eq.'null'))then       !.or.(TRIM(corrkdir).eq.'null_LowTeffStar')) then
          print*,'Infrared corrk gaseous absorption is set to zero if graybody=F'
+!$OMP MASTER         
          gasi8(1:L_NTREF,1:L_NPREF,1:L_REFVAR,1:L_NSPECTI,1:L_NGAUSS)=0.0
-      else  
+!$OMP END MASTER
+!$OMP BARRIER
+      else 
          file_id='/corrk_data/'//trim(adjustl(banddir))//'/corrk_gcm_IR.dat' 
          file_path=TRIM(datadir)//TRIM(file_id)
@@ -379,7 +389,10 @@
          endif
          
+!$OMP MASTER          	        
          open(111,file=TRIM(file_path),form='formatted')
          read(111,*) gasi8
          close(111)
+!$OMP END MASTER
+!$OMP BARRIER
      
          ! 'fzero' is a currently unused feature that allows optimisation
@@ -423,4 +436,5 @@
       endif
 
+!$OMP MASTER         	     
       if(nIR_limit.eq.0) then
          gasi8(1:L_NTREF,1:L_NPREF,1:L_REFVAR,1:L_NSPECTI,1:L_NGAUSS)=   &
@@ -465,4 +479,6 @@
          end do
       end do
+!$OMP END MASTER
+!$OMP BARRIER
 
 !     Interpolate the values:  first the longwave
@@ -653,8 +669,12 @@
 
 !     Deallocate local arrays
+!$OMP BARRIER
+!$OMP MASTER
       IF( ALLOCATED( gasi8 ) ) DEALLOCATE( gasi8 )
       IF( ALLOCATED( gasv8 ) ) DEALLOCATE( gasv8 )
       IF( ALLOCATED( pgasref ) ) DEALLOCATE( pgasref )
       IF( ALLOCATED( gastype ) ) DEALLOCATE( gastype )
+!$OMP END MASTER
+!$OMP BARRIER
 
       return
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surf_heat_transp_mod.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surf_heat_transp_mod.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surf_heat_transp_mod.F90	(revision 227)
@@ -7,5 +7,5 @@
 CONTAINS
 
-      SUBROUTINE divgrad_phy(nlevs,temp,delta)
+      SUBROUTINE divgrad_phy(ngrid,nlevs,temp,delta)
 
 
@@ -14,5 +14,5 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 #include "comcstfi.h"
@@ -20,12 +20,13 @@
 #include "comhdiff.h"
       
-      INTEGER nlevs, ll
-      REAL temp(ngridmx,nlevs)
+      INTEGER,INTENT(IN) :: ngrid, nlevs
+      REAL,INTENT(IN) :: temp(ngrid,nlevs)
+      REAL,INTENT(OUT) :: delta(ngrid,nlevs)
       REAL delta_2d(ip1jmp1,nlevs)
-      REAL delta(ngridmx,nlevs)
+      INTEGER :: ll
       REAL ghx(ip1jmp1,nlevs), ghy(ip1jm,nlevs)
 
 
-      CALL gr_fi_dyn(nlevs,ngridmx,iip1,jjp1,temp,delta_2d)
+      CALL gr_fi_dyn(nlevs,ngrid,iip1,jjp1,temp,delta_2d)
       CALL grad(nlevs,delta_2d,ghx,ghy)
       DO ll=1,nlevs
@@ -36,5 +37,5 @@
       END DO
       CALL diverg(nlevs,ghx,ghy,delta_2d)
-      CALL gr_dyn_fi(nlevs,iip1,jjp1,ngridmx,delta_2d,delta)
+      CALL gr_dyn_fi(nlevs,iip1,jjp1,ngrid,delta_2d,delta)
 
 
@@ -43,10 +44,10 @@
 
 
-      SUBROUTINE init_masquv(zmasq)
+      SUBROUTINE init_masquv(ngrid,zmasq)
      
       IMPLICIT NONE
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 #include "comcstfi.h"   
@@ -55,5 +56,6 @@
 
 
-      REAL zmasq(ngridmx)
+      INTEGER,INTENT(IN) :: ngrid
+      REAL zmasq(ngrid)
       REAL zmasq_2d(ip1jmp1)
       REAL ff(ip1jm)
@@ -66,5 +68,5 @@
       zmasqv=1.
 
-      CALL gr_fi_dyn(1,ngridmx,iip1,jjp1,zmasq,zmasq_2d)
+      CALL gr_fi_dyn(1,ngrid,iip1,jjp1,zmasq,zmasq_2d)
 
       DO i=1,ip1jmp1-1
@@ -104,5 +106,5 @@
 
 
-      SUBROUTINE slab_ekman2(tx_phy,ty_phy,ts_phy,dt_phy)
+      SUBROUTINE slab_ekman2(ngrid,tx_phy,ty_phy,ts_phy,dt_phy)
   
           use slab_ice_h 
@@ -111,5 +113,5 @@
       
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 #include "comcstfi.h"
@@ -118,4 +120,5 @@
 #include "comhdiff.h"
 
+      INTEGER,INTENT(IN) :: ngrid
       INTEGER ij
       REAL txv(ip1jm),fluxm(ip1jm),tyv(ip1jm)
@@ -123,6 +126,6 @@
       REAL tyu(ip1jmp1),txu(ip1jmp1),fluxz(ip1jmp1),fluxv(ip1jmp1)
       REAL dt(ip1jmp1,noceanmx),ts(ip1jmp1,noceanmx)
-      REAL tx_phy(ngridmx),ty_phy(ngridmx)
-      REAL dt_phy(ngridmx,noceanmx),ts_phy(ngridmx,noceanmx)
+      REAL tx_phy(ngrid),ty_phy(ngrid)
+      REAL dt_phy(ngrid,noceanmx),ts_phy(ngrid,noceanmx)
 
 
@@ -130,6 +133,6 @@
 
 ! Passage taux,y sur grilles 2d
-      CALL gr_fi_dyn(1,ngridmx,iip1,jjp1,tx_phy,txu)
-      CALL gr_fi_dyn(1,ngridmx,iip1,jjp1,ty_phy,tyu)
+      CALL gr_fi_dyn(1,ngrid,iip1,jjp1,tx_phy,txu)
+      CALL gr_fi_dyn(1,ngrid,iip1,jjp1,ty_phy,tyu)
 ! Passage grille u,v
 ! Multiplication par f ou eps.
@@ -144,5 +147,5 @@
             
 ! Calcul de T, Tdeep
-      CALL gr_fi_dyn(2,ngridmx,iip1,jjp1,ts_phy,ts)
+      CALL gr_fi_dyn(2,ngrid,iip1,jjp1,ts_phy,ts)
        
 ! Flux de masse
@@ -222,5 +225,5 @@
 
 ! Retour grille physique
-      CALL gr_dyn_fi(2,iip1,jjp1,ngridmx,dt,dt_phy)
+      CALL gr_dyn_fi(2,iip1,jjp1,ngrid,dt,dt_phy)
 
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surface_nature.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surface_nature.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surface_nature.F	(revision 227)
@@ -33,6 +33,6 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surfdat_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surfdat_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surfdat_h.F90	(revision 227)
@@ -5,12 +5,16 @@
 
        real,allocatable,dimension(:) :: albedodat ! albedo of bare ground
+!$OMP THREADPRIVATE(albedodat)
        ! Ehouarn: moved inertiedat to comsoil.h
        !      real inertiedat, ! thermal inertia
        real,allocatable,dimension(:) :: phisfi ! geopotential at ground level
+!$OMP THREADPRIVATE(phisfi)
        real,dimension(2) :: albedice
        real,dimension(2) :: emisice ! ice emissivity; 1:Northern hemisphere 2:Southern hemisphere
        real emissiv
        real,dimension(2) :: iceradius, dtemisice
+!$OMP THREADPRIVATE(albedice,emisice,emissiv,iceradius,dtemisice)
        real,allocatable,dimension(:) :: zmea,zstd,zsig,zgam,zthe
+!$OMP THREADPRIVATE(zmea,zstd,zsig,zgam,zthe)
 
        real,allocatable,dimension(:) :: dryness  !"Dryness coefficient" for grnd water ice sublimation
@@ -18,4 +22,5 @@
 
        logical,allocatable,dimension(:) :: watercaptag !! was in watercap.h
+!$OMP THREADPRIVATE(dryness,watercaptag)
 
        end module surfdat_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surfini.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surfini.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/surfini.F	(revision 227)
@@ -15,6 +15,6 @@
 c   Declarations:
 c   -------------
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "callkeys.h"
 c
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/tabfi.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/tabfi.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/tabfi.F	(revision 227)
@@ -34,5 +34,5 @@
 c                              comparer avec le day_ini dynamique)
 c
-c      - lmax:    tab_cntrl(tab0+2) (pour test avec nlayermx)
+c      - lmax:    tab_cntrl(tab0+2) (pour test avec nlayer)
 c
 c      - p_rad
@@ -51,9 +51,11 @@
       use iostart, only: get_var
       use mod_phys_lmdz_para, only: is_parallel
+      use planete_mod, only: year_day, periastr, apoastr, peri_day,
+     &                       obliquit, z0, lmixmin, emin_turb
 
       implicit none
  
 #include "comcstfi.h"
-#include "planete.h"
+!#include "planete.h"
 #include "netcdf.inc"
 #include "callkeys.h"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/totalcloudfrac.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/totalcloudfrac.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/totalcloudfrac.F90	(revision 227)
@@ -1,3 +1,3 @@
-      subroutine totalcloudfrac(ngrid,nq,rneb,totalrneb,pplev,pq,tau)
+      subroutine totalcloudfrac(ngrid,nlayer,nq,rneb,totalrneb,pplev,pq,tau)
 
       use watercommon_h
@@ -19,18 +19,19 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
 
       integer,intent(in) :: ngrid        ! number of atmospheric columns
+      integer,intent(in) :: nlayer       ! number of atmospheric layers
       integer,intent(in) :: nq           ! number of tracers
-      real,intent(in) :: rneb(ngrid,nlayermx)    ! cloud fraction     
+      real,intent(in) :: rneb(ngrid,nlayer)    ! cloud fraction     
       real,intent(out) :: totalrneb(ngrid)       ! total cloud fraction 
-      real,intent(in) :: pplev(ngrid,nlayermx+1) ! inter-layer pressure (Pa)
-      real,intent(in) :: pq(ngrid,nlayermx,nq)   ! tracers (.../kg_of_air)
-      real,intent(in) :: tau(ngrid,nlayermx)
+      real,intent(in) :: pplev(ngrid,nlayer+1) ! inter-layer pressure (Pa)
+      real,intent(in) :: pq(ngrid,nlayer,nq)   ! tracers (.../kg_of_air)
+      real,intent(in) :: tau(ngrid,nlayer)
 
-      real, dimension(nlayermx+1) :: masse
+      real, dimension(nlayer+1) :: masse
       integer, parameter          :: recovery=7
       integer ltau_max
@@ -47,5 +48,5 @@
       real clear,tau_min
       real, parameter ::  tau_c=0.1 !threshold of optical depth for the calculation of total cloud fraction 
-      real rneb2(nlayermx)
+      real rneb2(nlayer)
 
 
@@ -55,5 +56,5 @@
          if (recovery.eq.1) then
             clear = (1.-rneb(ig,1))
-            do l=2,nlayermx       
+            do l=2,nlayer      
                clear = clear*(1.-rneb(ig,l))
             enddo
@@ -62,5 +63,5 @@
          elseif (recovery.eq.2) then
             totalrneb(ig) = rneb(ig,1)
-            do l=2,14 !nlayermx       
+            do l=2,14 !nlayer    
                totalrneb(ig) = max(rneb(ig,l),totalrneb(ig))
             enddo
@@ -68,5 +69,5 @@
          elseif (recovery.eq.3) then
             totalrneb(ig) = rneb(ig,1)
-            do l=2,nlayermx       
+            do l=2,nlayer    
                totalrneb(ig) = min(rneb(ig,l),totalrneb(ig))
             enddo
@@ -77,5 +78,5 @@
          elseif (recovery.eq.5) then
             totalrneb(ig) = rneb(ig,1)            
-            do l=1,nlayermx
+            do l=1,nlayer
                masse(l)=pq(ig,l,igcm_h2o_ice)*(pplev(ig,l)-pplev(ig,l+1))
             enddo
@@ -85,10 +86,10 @@
          elseif (recovery.eq.6) then
             totalrneb(ig) = 0.            
-            do l=1,nlayermx
+            do l=1,nlayer
                masse(l)=pq(ig,l,igcm_h2o_ice)*(pplev(ig,l)-pplev(ig,l+1))
                masse(l)=max(masse(l),0.)
             enddo
             massetot=sum(masse,dim=1)
-            do l=1,nlayermx
+            do l=1,nlayer
                totalrneb(ig) = totalrneb(ig)+rneb(ig,l)*masse(l)/massetot
             enddo
@@ -96,10 +97,10 @@
          elseif (recovery.eq.7) then
 
-            rneb2(:)=rneb(ig,1:nlayermx)
-	    tau_min=MIN(tau_c,MAXVAL(tau(ig,1:nlayermx))/2.)
-            do l=1,nlayermx
+            rneb2(:)=rneb(ig,1:nlayer)
+	    tau_min=MIN(tau_c,MAXVAL(tau(ig,1:nlayer))/2.)
+            do l=1,nlayer
                if(tau(ig,l)<tau_min) rneb2(l)=0.      	
             enddo
-            totalrneb(ig)=maxval(rneb2(1:nlayermx))
+            totalrneb(ig)=maxval(rneb2(1:nlayer))
 
          endif                  ! (recovery=)   
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/tracer_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/tracer_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/tracer_h.F90	(revision 227)
@@ -19,4 +19,6 @@
       real rho_co2     ! CO2 ice density (kg.m-3)
       real ref_r0        ! for computing reff=ref_r0*r0 (in log.n. distribution)
+!$OMP THREADPRIVATE(noms,mmol,radius,rho_q,qext,alpha_lift,alpha_devil,qextrhor, &
+	!$OMP varian,r3n_q,rho_dust,rho_ice,rho_co2,ref_r0)
 
 ! tracer indexes: these are initialized in initracer and should be 0 if the
@@ -47,4 +49,7 @@
       integer :: igcm_ar_n2 ! for simulations using co2 +neutral gaz
       integer :: igcm_co2_ice ! CO2 ice 
+!$OMP THREADPRIVATE(igcm_dustbin,igcm_dust_mass,igcm_dust_number,igcm_h2o_vap,igcm_h2o_ice, &
+	!$OMP igcm_co2,igcm_co,igcm_o,igcm_o1d,igcm_o2,igcm_o3,igcm_h,igcm_h2,igcm_oh,	    &
+	!$OMP igcm_ho2,igcm_h2o2,igcm_n2,igcm_ar,igcm_ar_n2,igcm_co2_ice)
 
        end module tracer_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/turbdiff.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/turbdiff.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/turbdiff.F90	(revision 227)
@@ -41,6 +41,6 @@
 !     ------------
 
-      include "dimensions.h"
-      include "dimphys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
       include "comcstfi.h"
       include "callkeys.h"
@@ -48,5 +48,6 @@
 !     arguments
 !     ---------
-      INTEGER,INTENT(IN) :: ngrid,nlay
+      INTEGER,INTENT(IN) :: ngrid
+      INTEGER,INTENT(IN) :: nlay
       REAL,INTENT(IN) :: ptimestep
       REAL,INTENT(IN) :: pplay(ngrid,nlay),pplev(ngrid,nlay+1)
@@ -86,18 +87,18 @@
 
       REAL z4st,zdplanck(ngrid)
-      REAL zkv(ngrid,nlayermx+1),zkh(ngrid,nlayermx+1)
+      REAL zkv(ngrid,nlay+1),zkh(ngrid,nlay+1)
       REAL zcdv(ngrid),zcdh(ngrid)
       REAL zcdv_true(ngrid),zcdh_true(ngrid)
-      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
-      REAL zh(ngrid,nlayermx),zt(ngrid,nlayermx)
+      REAL zu(ngrid,nlay),zv(ngrid,nlay)
+      REAL zh(ngrid,nlay),zt(ngrid,nlay)
       REAL ztsrf(ngrid)
       REAL z1(ngrid),z2(ngrid)
-      REAL zmass(ngrid,nlayermx)
-      REAL zfluxv(ngrid,nlayermx),zfluxt(ngrid,nlayermx),zfluxq(ngrid,nlayermx)
-      REAL zb0(ngrid,nlayermx)
-      REAL zExner(ngrid,nlayermx),zovExner(ngrid,nlayermx)
-      REAL zcv(ngrid,nlayermx),zdv(ngrid,nlayermx)  !inversion coefficient for winds
-      REAL zct(ngrid,nlayermx),zdt(ngrid,nlayermx)  !inversion coefficient for temperature
-      REAL zcq(ngrid,nlayermx),zdq(ngrid,nlayermx)  !inversion coefficient for tracers
+      REAL zmass(ngrid,nlay)
+      REAL zfluxv(ngrid,nlay),zfluxt(ngrid,nlay),zfluxq(ngrid,nlay)
+      REAL zb0(ngrid,nlay)
+      REAL zExner(ngrid,nlay),zovExner(ngrid,nlay)
+      REAL zcv(ngrid,nlay),zdv(ngrid,nlay)  !inversion coefficient for winds
+      REAL zct(ngrid,nlay),zdt(ngrid,nlay)  !inversion coefficient for temperature
+      REAL zcq(ngrid,nlay),zdq(ngrid,nlay)  !inversion coefficient for tracers
       REAL zcst1
       REAL zu2!, a
@@ -106,11 +107,12 @@
 
       LOGICAL,SAVE :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall)
       
 !     Tracers
 !     -------
       INTEGER iq
-      REAL zq(ngrid,nlayermx,nq)
-      REAL zqnoevap(ngrid,nlayermx) !special for water case to compute where evaporated water goes.
-      REAL pdqevap(ngrid,nlayermx) !special for water case to compute where evaporated water goes.
+      REAL zq(ngrid,nlay,nq)
+      REAL zqnoevap(ngrid,nlay) !special for water case to compute where evaporated water goes.
+      REAL pdqevap(ngrid,nlay) !special for water case to compute where evaporated water goes.
       REAL zdmassevap(ngrid)
       REAL rho(ngrid)         ! near-surface air density
@@ -123,4 +125,5 @@
 
       integer, save :: ivap, iliq, iliq_surf,iice_surf ! also make liq for clarity on surface...
+!$OMP THREADPRIVATE(ivap,iliq,iliq_surf,iice_surf)
 
       real, parameter :: karman=0.4
@@ -241,5 +244,5 @@
 !     ------------------------------------------------------ 
 
-      call vdif_kc(ngrid,ptimestep,g,pzlev,pzlay,pu,pv,zh,zcdv_true,pq2,zkv,zkh) !JL12 why not call vdif_kc with updated winds and temperature 
+      call vdif_kc(ngrid,nlay,ptimestep,g,pzlev,pzlay,pu,pv,zh,zcdv_true,pq2,zkv,zkh) !JL12 why not call vdif_kc with updated winds and temperature 
       
 !     Adding eddy mixing to mimic 3D general circulation in 1D
@@ -262,5 +265,5 @@
  
 !JL12 calculate the flux coefficients (tables multiplied elements by elements)
-      zfluxv(1:ngrid,1:nlayermx)=zkv(1:ngrid,1:nlayermx)*zb0(1:ngrid,1:nlayermx)
+      zfluxv(1:ngrid,1:nlay)=zkv(1:ngrid,1:nlay)*zb0(1:ngrid,1:nlay)
       
 !-----------------------------------------------------------------------
@@ -364,6 +367,6 @@
 !     JL12 calculate the flux coefficients (tables multiplied elements by elements)
 !     ---------------------------------------------------------------
-      zfluxq(1:ngrid,1:nlayermx)=zkh(1:ngrid,1:nlayermx)*zb0(1:ngrid,1:nlayermx) !JL12 we save zfluxq which doesn't need the Exner factor
-      zfluxt(1:ngrid,1:nlayermx)=zfluxq(1:ngrid,1:nlayermx)*zExner(1:ngrid,1:nlayermx)
+      zfluxq(1:ngrid,1:nlay)=zkh(1:ngrid,1:nlay)*zb0(1:ngrid,1:nlay) !JL12 we save zfluxq which doesn't need the Exner factor
+      zfluxt(1:ngrid,1:nlay)=zfluxq(1:ngrid,1:nlay)*zExner(1:ngrid,1:nlay)
 
       DO ig=1,ngrid
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdif_cd.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdif_cd.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdif_cd.F	(revision 227)
@@ -55,4 +55,5 @@
       DATA firstcal/.true./
       SAVE b,c,d,karman,c2b,c3bc,c3b,firstcal,umin2
+!$OMP THREADPRIVATE(b,c,d,karman,c2b,c3bc,c3b,firstcal,umin2)
 
 c-----------------------------------------------------------------------
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdif_kc.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdif_kc.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdif_kc.F	(revision 227)
@@ -1,7 +1,7 @@
-      SUBROUTINE vdif_kc(ngrid,dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn)
+      SUBROUTINE vdif_kc(ngrid,nlay,dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn)
       IMPLICIT NONE
 c.......................................................................
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 c.......................................................................
 c
@@ -28,14 +28,15 @@
 c.......................................................................
       INTEGER,INTENT(IN) :: ngrid
+      INTEGER,INTENT(IN) :: nlay
       REAL,INTENT(IN) :: dt,g
-      REAL,INTENT(IN) :: zlev(ngrid,nlayermx+1)
-      REAL,INTENT(IN) :: zlay(ngrid,nlayermx)
-      REAL,INTENT(IN) :: u(ngrid,nlayermx)
-      REAL,INTENT(IN) :: v(ngrid,nlayermx)
-      REAL,INTENT(IN) :: teta(ngrid,nlayermx)
+      REAL,INTENT(IN) :: zlev(ngrid,nlay+1)
+      REAL,INTENT(IN) :: zlay(ngrid,nlay)
+      REAL,INTENT(IN) :: u(ngrid,nlay)
+      REAL,INTENT(IN) :: v(ngrid,nlay)
+      REAL,INTENT(IN) :: teta(ngrid,nlay)
       REAL,INTENT(IN) :: cd(ngrid)
-      REAL,INTENT(INOUT) :: q2(ngrid,nlayermx+1)
-      REAL,INTENT(OUT) :: km(ngrid,nlayermx+1)
-      REAL,INTENT(OUT) :: kn(ngrid,nlayermx+1)
+      REAL,INTENT(INOUT) :: q2(ngrid,nlay+1)
+      REAL,INTENT(OUT) :: km(ngrid,nlay+1)
+      REAL,INTENT(OUT) :: kn(ngrid,nlay+1)
 c.......................................................................
 c
@@ -50,9 +51,8 @@
 c
 c.......................................................................
-      INTEGER,PARAMETER :: nlay=nlayermx
-      INTEGER,PARAMETER :: nlev=nlayermx+1
-      REAL unsdz(ngrid,nlayermx)
-      REAL unsdzdec(ngrid,nlayermx+1)
-      REAL q(ngrid,nlayermx+1)
+      INTEGER :: nlev
+      REAL unsdz(ngrid,nlay)
+      REAL unsdzdec(ngrid,nlay+1)
+      REAL q(ngrid,nlay+1)
 c.......................................................................
 c
@@ -64,5 +64,5 @@
 c
 c.......................................................................
-      REAL kmpre(ngrid,nlayermx+1)
+      REAL kmpre(ngrid,nlay+1)
       REAL qcstat
       REAL q2cstat
@@ -72,5 +72,5 @@
 c
 c.......................................................................
-      REAL long(ngrid,nlayermx+1)
+      REAL long(ngrid,nlay+1)
 c.......................................................................
 c
@@ -95,8 +95,8 @@
       REAL mcstat
       REAL m2cstat
-      REAL m(ngrid,nlayermx+1)
-      REAL mpre(ngrid,nlayermx+1)
-      REAL m2(ngrid,nlayermx+1)
-      REAL n2(ngrid,nlayermx+1)
+      REAL m(ngrid,nlay+1)
+      REAL mpre(ngrid,nlay+1)
+      REAL m2(ngrid,nlay+1)
+      REAL n2(ngrid,nlay+1)
 c.......................................................................
 c
@@ -120,9 +120,9 @@
       LOGICAL gnsup
       REAL gm
-c      REAL ri(ngrid,nlayermx+1)
-      REAL sn(ngrid,nlayermx+1)
-      REAL snq2(ngrid,nlayermx+1)
-      REAL sm(ngrid,nlayermx+1)
-      REAL smq2(ngrid,nlayermx+1)
+c      REAL ri(ngrid,nlaye+1)
+      REAL sn(ngrid,nlay+1)
+      REAL snq2(ngrid,nlay+1)
+      REAL sm(ngrid,nlay+1)
+      REAL smq2(ngrid,nlay+1)
 c.......................................................................
 c
@@ -179,4 +179,5 @@
 
 ! initialization of local variables:
+      nlev=nlay+1
       long(:,:)=0.
       n2(:,:)=0.
